//+------------------------------------------------------------------+
//|                                                   validation.mq4 |
//|                        Copyright 2022, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
//#property strict


//+------------------------------------------------------------------+
//| Func return Field Prices Values of current Periodicity           |
//+------------------------------------------------------------------+
double CalculateDevPrice(int AppliedPrice, int i)
  {

   double devPrice;
   switch(AppliedPrice)
     {
      case 0:
        {
         devPrice=Close[i];
         break;
        }
      case 1:
        {
         devPrice=Open[i];
         break;
        }
      case 2:
        {
         devPrice=High[i];
         break;
        }
      case 3:
        {
         devPrice=Low[i];
         break;
        }
     }

   return devPrice;
  }

//=====================================================================================================================================================
//=====================================================================================================================================================
//+------------------------------------------------------------------+
//| Func return Field Prices Values of Multiple Periodicity          |
//+------------------------------------------------------------------+
double CalculateMTFFieldPrice(int MTFAppliedPrice,int MTF ,int i )
  {

   double MTFFieldPrice;
   switch(MTFAppliedPrice)
     {
      case 0:
        {
         MTFFieldPrice=iClose(NULL,MTF,i); 
         break;
        }
      case 1:
        {
         MTFFieldPrice=iOpen(NULL,MTF,i);   
         break;
        }
      case 2:
        {
         MTFFieldPrice=iHigh(NULL,MTF,i);   
         break;
        }
      case 3:
        {
         MTFFieldPrice=iLow(NULL,MTF,i); 
         break;
        }
     }

   return MTFFieldPrice;
  } 
//-----------------------------------------------------
//-----------------------------------------------------
//=================================================================================================================================================================
//=================================================================================================================================================================
//+-------------------------+
//| Create Drop Down Lists  |
//+-------------------------+


// drop down list for Hist Type
//-----------------------------
enum Hist_Type
  {
   HistHist     = DRAW_HISTOGRAM,   //Dev_Histogram   
   HistLine     = DRAW_LINE,       //Dev_Line
   HistHidden   = DRAW_NONE,      //Dev_Hidden
  };
//-----------------------------------------------------
//-----------------------------------------------------
// drop down list for line style
//-------------------------------
enum linesstyle
  {
   Lines  = DRAW_LINE,   //Lines   
   Hidden = DRAW_NONE   //Hidden
  };
//------------------------------------------------
//------------------------------------------------
// drop down list for line Type
//-----------------------------
enum linestypes
  {
   Line  = STYLE_SOLID,    //SOLID   
   Dots  = STYLE_DOT,     //DOT
   Dachs = STYLE_DASH,   //DASH
  };
  

//-------------------------------------------   
#include <MovingAverages.mqh>
#property indicator_separate_window
//-------------------------------------------
// num of Buffers::
#property indicator_buffers 19
//-------------------------------------------
#property indicator_color1 clrPurple
#property indicator_type1  DRAW_NONE
#property indicator_width1 2
#property indicator_label1 ""
//-------------------------------------------
//-------------------------------------------
#property indicator_color2 clrPurple
#property indicator_type2  DRAW_NONE
#property indicator_width2 2
#property indicator_label2 ""
//-------------------------------------------
//-------------------------------------------
#property indicator_color3 clrPurple
#property indicator_type3  DRAW_NONE
#property indicator_width3 2
#property indicator_label3 ""
//-------------------------------------------
//-------------------------------------------
#property indicator_color4 clrPurple
#property indicator_type4  DRAW_NONE
#property indicator_width4 2
#property indicator_label4 ""
//-------------------------------------------
//-------------------------------------------
#property indicator_color5 clrPurple
#property indicator_type5  DRAW_NONE
#property indicator_width5 2
#property indicator_label5 ""
//-------------------------------------------
//-------------------------------------------
#property indicator_color6 clrPurple
#property indicator_type6  DRAW_NONE
#property indicator_width6 2
#property indicator_label6 ""
//-------------------------------------------
//-------------------------------------------
//-------------------------------------------
//-------------------------------------------
#property indicator_color7 clrPurple
#property indicator_type7  DRAW_NONE
#property indicator_width7 2
#property indicator_label7 ""
//-------------------------------------------
//-------------------------------------------
#property indicator_color8 clrPurple
#property indicator_type8  DRAW_NONE
#property indicator_width8 2
#property indicator_label8 ""
//-------------------------------------------
//-------------------------------------------
#property indicator_color9 clrPurple
#property indicator_type9  DRAW_NONE
#property indicator_width9 2
#property indicator_label9 ""
//--------------------------------------------
//--------------------------------------------
#property indicator_color10 clrPurple
#property indicator_type10  DRAW_NONE
#property indicator_width10 2
#property indicator_label10 ""
//--------------------------------------------
//--------------------------------------------

//-----------------------------------------------------
//-----------------------------------------------------
//--------------------------------------------
//--------------------------------------------
#property indicator_color11 clrPurple
#property indicator_type11  DRAW_NONE
#property indicator_width11 2
#property indicator_label11 ""
//--------------------------------------------
//--------------------------------------------
#property indicator_color12 clrPurple
#property indicator_type12  DRAW_NONE
#property indicator_width12 2
#property indicator_label12 ""
//--------------------------------------------
//--------------------------------------------
#property indicator_color13 clrPurple
#property indicator_type13  DRAW_NONE
#property indicator_width13 2
#property indicator_label13 ""
//--------------------------------------------
//--------------------------------------------
#property indicator_color14 clrPurple
#property indicator_type14  DRAW_NONE
#property indicator_width14 2
#property indicator_label14 ""
//--------------------------------------------
//--------------------------------------------
#property indicator_color15 clrPurple
#property indicator_type15  DRAW_NONE
#property indicator_width15 2
#property indicator_label15 ""
//--------------------------------------------
//--------------------------------------------
#property indicator_color16 clrPurple
#property indicator_type16  DRAW_NONE
#property indicator_width16 2
#property indicator_label16 ""
//--------------------------------------------
//--------------------------------------------
#property indicator_color17 clrPurple
#property indicator_type17  DRAW_NONE
#property indicator_width17 2
#property indicator_label17 ""
//--------------------------------------------
//--------------------------------------------
#property indicator_color18 clrPurple
#property indicator_type18  DRAW_NONE
#property indicator_width18 2
#property indicator_label18 ""

#property indicator_color19 clrYellow
#property indicator_type19  DRAW_NONE
#property indicator_width19 8
#property indicator_label19 ""

// 1st Dev paramters::
//--------------------
input string             MTFDevParam          = "---------------------------------------------------";
//input bool               DevTFSwitch          = False;  
input ENUM_TIMEFRAMES    DevTF                = 0;      
input ENUM_APPLIED_PRICE MTFDevAppliedPrice   = 0;
input ENUM_APPLIED_PRICE MTFDevMAAppliedPrice = 0;
input ENUM_MA_METHOD     MTFDevMAMethod       = 0;
input int                MTFDevMAPeriod       = 20;   

input Hist_Type          MTFDevType           = HistHidden;
input ENUM_LINE_STYLE    MTFDevStyle          = 0;   
input color              MTFDevUPClr          = clrGreen;     
input color              MTFDevDownClr        = clrRed;
input linesstyle         MTFDevZeroType       = Hidden;  
input ENUM_LINE_STYLE    MTFDevZeroStyle      = 0; 
input color              MTFDevZeroClr        = clrGold;
input int                MTFDevWidth          = 1;
//-----------------------------------------------------
//-----------------------------------------------------
//-----------------------------------------------------
//-----------------------------------------------------
// 2nd Dev paramters::
//--------------------
input string             MTFDev1Param          = "---------------------------------------------------";
//input bool               Dev1TFSwitch          = False;
input ENUM_TIMEFRAMES    Dev1TF                = 0;
input ENUM_APPLIED_PRICE MTFDev1AppliedPrice   = 0;
input ENUM_APPLIED_PRICE MTFDev1MAAppliedPrice = 0;
input ENUM_MA_METHOD     MTFDev1MAMethod       = 0;
input int                MTFDev1MAPeriod       = 20;  
input Hist_Type          MTFDev1Type           = HistHidden;
input ENUM_LINE_STYLE    MTFDev1Style          = 0; 
input color              MTFDev1UPClr          = clrGreen;     
input color              MTFDev1DownClr        = clrRed;
input linesstyle         MTFDev1ZeroType       = Hidden;
input ENUM_LINE_STYLE    MTFDev1ZeroStyle      = 0; 
input color              MTFDev1ZeroClr        = clrGold;
input int                MTFDev1Width          = 1;
//-----------------------------------------------------
//-----------------------------------------------------
// Plots Dev MA Buff
//--------------------------------------
double DevMABuffer   [];       
double MTFDev        [];  
double DevMABuff     [];
double DevFPBuff     [];
double DevBuff       []; 
double upMTFDev      [];
double downMTFDev    [];
double ZupMTFDev     [];
double ZdownMTFDev   []; 
//--------------------------------------
//--------------------------------------
//--------------------------------------
//--------------------------------------
// Plots Dev1 MA Buff
//--------------------------------------
double Dev1MABuffer  [];
double MTFDev1       [];
double Dev1MABuff    [];
double Dev1FPBuff    [];
double Dev1Buff      [];
double upMTFDev1     [];
double downMTFDev1   []; 
double ZupMTFDev1    [];
double ZdownMTFDev1  []; 
//--------------------------------------

double Histogram  []; 
//--------------------------------------
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   IndicatorBuffers(19);
//-------------------------------------------------------------------------------------------------
            // MTF Dev Arrays
//-------------------------------------------------------------------------------------------------
// MTF Dev Buffs for Plotting:
   SetIndexBuffer(0  , DevMABuffer);
   SetIndexStyle (0  , DRAW_NONE); 
   SetIndexLabel (0  , "");

   SetIndexBuffer(1 , MTFDev);
   SetIndexStyle (1 , DRAW_NONE);   
   SetIndexLabel (1 , "");
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
// MTF Dev Buffs for calculations:
   SetIndexBuffer(2 , DevMABuff);
   SetIndexStyle (2 , DRAW_NONE);  
   SetIndexLabel (2 , ""); 


   SetIndexBuffer(3 , DevFPBuff); 
   SetIndexStyle (3 , DRAW_NONE);
   SetIndexLabel (3 , ""); 


   SetIndexBuffer(4 , DevBuff);
   SetIndexStyle (4 , DRAW_NONE); 
   SetIndexLabel (4 , ""); 
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
// MTFDev3 Slope UP / Down 
   SetIndexBuffer(5 , upMTFDev);
   SetIndexStyle (5 , MTFDevType  , MTFDevStyle , MTFDevWidth , MTFDevUPClr);   
   SetIndexLabel (5 , "");

   SetIndexBuffer(6 , downMTFDev);
   SetIndexStyle (6 , MTFDevType , MTFDevStyle , MTFDevWidth , MTFDevDownClr);
   SetIndexLabel (6 , "");
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
// MTFDev3 Slope Zero 
   SetIndexStyle (7 , MTFDevZeroType , MTFDevZeroStyle , MTFDevWidth , MTFDevZeroClr); 
   SetIndexBuffer(7 , ZupMTFDev);
   SetIndexLabel (7 , "");
   
   SetIndexStyle (8 , MTFDevZeroType , MTFDevZeroStyle , MTFDevWidth , MTFDevZeroClr); 
   SetIndexBuffer(8 , ZdownMTFDev); 
   SetIndexLabel (8 , "");
//=================================================================================================================================================================================
//=================================================================================================================================================================================
//=================================================================================================================================================================================
//=================================================================================================================================================================================
//-------------------------------------------------------------------------------------------------
            // MTF Dev1 Arrays
//-------------------------------------------------------------------------------------------------
// MTF Dev Buffs for Plotting:
   SetIndexBuffer(9 , Dev1MABuffer);
   SetIndexStyle (9 , DRAW_NONE); 
   SetIndexLabel (9 , "");

   SetIndexBuffer(10 , MTFDev1);
   SetIndexStyle (10 , DRAW_NONE); 
   SetIndexLabel (10 , "");
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
// MTF Dev Buffs for calculations:
   SetIndexBuffer(11 , Dev1MABuff); 
   SetIndexStyle (11 , DRAW_NONE);
   SetIndexLabel (11 , ""); 

   SetIndexBuffer(12 , Dev1FPBuff); 
   SetIndexStyle (12 , DRAW_NONE); 
   SetIndexLabel (12 , ""); 

   SetIndexBuffer(13 , Dev1Buff); 
   SetIndexStyle (13 , DRAW_NONE); 
   SetIndexLabel (13 , "");
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
// MTFDev3 Slope UP / Down 
   SetIndexBuffer(14 , upMTFDev1);
   SetIndexStyle (14 , MTFDev1Type  , MTFDev1Style , MTFDev1Width , MTFDev1UPClr); 
   SetIndexLabel (14 , "");

   SetIndexBuffer(15 , downMTFDev1);
   SetIndexStyle (15 , MTFDev1Type , MTFDev1Style , MTFDev1Width , MTFDev1DownClr);
   SetIndexLabel (15 , "");
//------------------------------------------------------------------------------------------------- 
//-------------------------------------------------------------------------------------------------
// MTFDev1 Slope Zero 
   SetIndexStyle (16  , MTFDev1ZeroType , MTFDev1ZeroStyle , MTFDev1Width , MTFDev1ZeroClr);   
   SetIndexBuffer(16  , ZupMTFDev1);
   SetIndexLabel (16 , "");
   
   SetIndexStyle (17 , MTFDev1ZeroType , MTFDev1ZeroStyle , MTFDev1Width , MTFDev1ZeroClr); 
   SetIndexBuffer(17 , ZdownMTFDev1); 
   SetIndexLabel (17 , "");
   
   SetIndexStyle (18 , DRAW_HISTOGRAM); 
   SetIndexBuffer(18 , Histogram); 
   SetIndexLabel (18 , "");
   
//=================================================================================================================================================================================
//=================================================================================================================================================================================
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int countedBars = IndicatorCounted();
   if(countedBars < 0)
      countedBars = 0;

   if(countedBars > 0)
      countedBars--;
   int limit = rates_total - countedBars;
   
   for(int iDev = limit; iDev>= 0; iDev--)
      {
      // Shift MTF  Dev MA to fit it on current chart: ///////////  effect Multiple Bars
      int Devshift = iBarShift(NULL, DevTF, Time[iDev], true);
      int Dev1shift = iBarShift(NULL, Dev1TF, Time[iDev], true);
      if (Devshift == -1) continue;
      if (Dev1shift == -1) continue;
      //-----------------------------------------
      // MTF  Dev MA Calculation::
      DevMABuffer[iDev] = iMA(NULL, DevTF, MTFDevMAPeriod, 0, MTFDevMAMethod, MTFDevMAAppliedPrice, iDev);
      Dev1MABuffer[iDev] = iMA(NULL, Dev1TF, MTFDev1MAPeriod, 0, MTFDev1MAMethod, MTFDev1MAAppliedPrice, iDev);
      //-----------------------------------------
       // MTF  Dev FieldPrice Calculation::
      double DevFP   = CalculateMTFFieldPrice(MTFDevAppliedPrice   ,DevTF  ,iDev );
      double Dev1FP   = CalculateMTFFieldPrice(MTFDev1AppliedPrice   ,Dev1TF  ,iDev );
      /////////////////////Devpricearr[iDev] =  CalculateMTFFieldPrice(MTFDevAppliedPrice   ,DevTF   ,Devshift ); 
      //-----------------------------------------
      // MTF  Dev Calculation::
      MTFDev  [iDev]   = DevFP    -  DevMABuffer  [iDev];
      MTFDev1  [iDev]  = Dev1FP   -  Dev1MABuffer  [iDev];
      ///////////////////////////////////////////Comment("D-i= "+ DoubleToString(MTFDev  [iDev],8)+"\n"+"D-0= "+ DoubleToString(MTFDev  [0],8)+"\n"+"D-1= "+ DoubleToString(MTFDev  [1],8)+"\n"+"D-2= "+ DoubleToString(MTFDev  [2],8)+"D-3= "+ DoubleToString(MTFDev  [3],8)+"D-4= "+ DoubleToString(MTFDev  [4],8)+"D-5= "+ DoubleToString(MTFDev  [5],8)+"D-6= "+ DoubleToString(MTFDev  [6],8)+"D-7= "+ DoubleToString(MTFDev  [7],8)+"D-8= "+ DoubleToString(MTFDev  [8],8)+"D-9= "+ DoubleToString(MTFDev  [9],8)+"D-10= "+ DoubleToString(MTFDev  [10],8)+"D-11= "+ DoubleToString(MTFDev  [11],8)+"D-12= "+ DoubleToString(MTFDev  [12],8)+"D-13= "+ DoubleToString(MTFDev  [13],8)+"D-14= "+ DoubleToString(MTFDev  [14],8)+"D-15= "+ DoubleToString(MTFDev  [15],8)+"D-16= "+ DoubleToString(MTFDev  [16],8)+"D-17= "+ DoubleToString(MTFDev  [17],8)+"D-18= "+ DoubleToString(MTFDev  [18],8)+"D-19= "+ DoubleToString(MTFDev  [19],8)+"D-20= "+ DoubleToString(MTFDev  [20],8));
      //---------------------------------------------------
      //=======================================================================================================================================================================
      //=======================================================================================================================================================================
      //======================================================================================================================================================================= 
      /////////////////////////Comment("D-i= "+ DoubleToString(DevBuff  [Devshift],8)+"\n"+"D-0= "+ DoubleToString(DevBuff  [0],8)+"\n"+"D-1= "+ DoubleToString(DevBuff  [1],8)+"\n"+"D-2= "+ DoubleToString(DevBuff  [2],8)+"D-3= "+ DoubleToString(DevBuff  [3],8)+"D-4= "+ DoubleToString(DevBuff  [4],8)+"D-5= "+ DoubleToString(DevBuff  [5],8)+"D-6= "+ DoubleToString(DevBuff  [6],8)+"D-7= "+ DoubleToString(DevBuff  [7],8)+"D-8= "+ DoubleToString(DevBuff  [8],8)+"D-9= "+ DoubleToString(DevBuff  [9],8)+"D-10= "+ DoubleToString(DevBuff  [10],8)+"D-11= "+ DoubleToString(DevBuff  [11],8)+"D-12= "+ DoubleToString(DevBuff  [12],8)+"D-13= "+ DoubleToString(DevBuff  [13],8)+"D-14= "+ DoubleToString(DevBuff  [14],8)+"D-15= "+ DoubleToString(DevBuff  [15],8)+"D-16= "+ DoubleToString(DevBuff  [16],8)+"D-17= "+ DoubleToString(DevBuff  [17],8)+"D-18= "+ DoubleToString(DevBuff  [18],8)+"D-19= "+ DoubleToString(DevBuff  [19],8)+"D-20= "+ DoubleToString(DevBuff  [20],8));
//=======================================================================================================================================================================
//=======================================================================================================================================================================
//=======================================================================================================================================================================
      
      ///////////  effect Multiple Bars
      // Get Dev as slope up down and zero Histogram Process
      if(MTFDevType == HistHist)
         { 
            // UP / Down of MTF  Dev::
            if(MTFDev[iDev] > 0)
              {
               upMTFDev  [iDev] = MTFDev[iDev];
               downMTFDev[iDev] = 0;
              }
            else
              {
               if(MTFDev[iDev] < 0)
                 {
                  downMTFDev[iDev] = MTFDev[iDev];
                  upMTFDev  [iDev] = 0;
                 }
               else
                 {
                  upMTFDev  [iDev] = 0;
                  downMTFDev[iDev] = 0;
                 }
              }  
         }
//=======================================================================================================================================================================
//=======================================================================================================================================================================
//=======================================================================================================================================================================
//=======================================================================================================================================================================
      //-------------------------------------------------------------------------
      //-------------------------------------------------------------------------  
      if(MTFDevType == HistLine)
      {
      
         //MAs2HistChoicesSlopeUPBuff[s]   =  EMPTY_VALUE;        
         //MAs2HistChoicesSlopeDownBuff[s] =  EMPTY_VALUE; ZupMTFDev ZdownMTFDev
         //------------------------------------------------
         if(MTFDev[iDev]>0)
           {
            upMTFDev[iDev]              = MTFDev[iDev];
            //------------------------------------------------
            if(iDev <  (rates_total-1)&& (upMTFDev[iDev+1] == EMPTY_VALUE )){
               ZupMTFDev[iDev]   = MTFDev[iDev];
               ZupMTFDev[iDev+1] = MTFDev[iDev+1];
               //------------------------------------------------
               }
            
           }
         else 
           {
            downMTFDev[iDev]              = MTFDev[iDev];
            //------------------------------------------------
            if(iDev <  (rates_total-1)&& (downMTFDev[iDev+1] == EMPTY_VALUE  )){
              ZdownMTFDev[iDev]   = MTFDev[iDev];
              ZdownMTFDev[iDev+1] = MTFDev[iDev+1];
              //------------------------------------------------
              
              }
            
           }
  
      }
      
      
      
      //****************************************************************************
      // Get Dev1 as slope up down and zero Histogram Process
      if(MTFDev1Type == HistHist)
         {
            // UP / Down of Dev1::
            if(MTFDev1[iDev] > 0)
              {
               upMTFDev1  [iDev] = MTFDev1[iDev];
               downMTFDev1[iDev] = 0;
              }
            else
              {
               if(MTFDev1[iDev] < 0)
                 {
                  downMTFDev1[iDev] = MTFDev1[iDev];
                  upMTFDev1  [iDev] = 0;
                 }
               else
                 {
                  upMTFDev1  [iDev] = 0;
                  downMTFDev1[iDev] = 0;
                 }
              } 
         }
         
      //------------------------------------------------------------------
      //------------------------------------------------------------------
      // Get Dev1 slope up down and zero as line
      if(MTFDev1Type == HistLine)
      {
      
         //MAs2HistChoicesSlopeUPBuff[s]   =  EMPTY_VALUE;        
         //MAs2HistChoicesSlopeDownBuff[s] =  EMPTY_VALUE; ZupMTFDev ZdownMTFDev
         //------------------------------------------------
         if(MTFDev1[iDev]>0)
           {
            upMTFDev1[iDev]              = MTFDev1[iDev];
            //------------------------------------------------
            if(iDev <  (rates_total-1)&& (upMTFDev1[iDev+1] == EMPTY_VALUE )){
               ZupMTFDev1[iDev]   = MTFDev1[iDev];
               ZupMTFDev1[iDev+1] = MTFDev1[iDev+1];
               //------------------------------------------------
               }
            
           }
         else 
           {
            downMTFDev1[iDev]              = MTFDev1[iDev];
            //------------------------------------------------
            if(iDev <  (rates_total-1)&& (downMTFDev1[iDev+1] == EMPTY_VALUE  )){
              ZdownMTFDev1[iDev]   = MTFDev1[iDev];
              ZdownMTFDev1[iDev+1] = MTFDev1[iDev+1];
              //------------------------------------------------
              
              }
            
           }
         
      } 
      
      
      
      
      
      
      
      Histogram[iDev] = MTFDev[iDev] + MTFDev1[iDev];
      
      
      
      
      
      
        
   }
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
